load('JolloisPoggiPortier.Rdata')
library(randomForest)

VarImp_Effet_RF <- function(x, st = 'XXX') {
# Variable Importance and Marginal Effect with Random Forest
# Input :
#	x : data matrix
#	st : station name
	# shell is for Windows. 
	# Under Unix-like system, use system() function
	if (all(dir() != "RF")) shell('mkdir RF')
	setwd('RF')
	if (all(dir() != st)) shell(paste('mkdir', st))
	setwd(st)
	res <- randomForest(formula(x), data=x, importance=T)
	# Variable importance - figure
	varImpPlot(res, type=1, sort=T, 
		main='RF - Variable importance')
	dev.print(device=postscript, 
		paste('RF_', st, '_Imp.eps', sep=''))
	# Variable importance - table
	o = order(importance(res, type=1), decreasing=T)
	r = importance(res)[o,]
	sink(paste('RF_', st, '_Imp.txt', sep=''))
	cat('RF - Variable Importance - % Increment MSE\n\n')
	print(as.matrix(round(r, 2)[,1]))
	sink()
	# Marginal effect for each variable
	for (i in 2:dim(x)[2]) {
		do.call('partialPlot', list(res, x, names(x)[i], 
			main=paste("Marginal effect -", names(x)[i]),
			xlab=names(x)[i]))
		dev.print(device=postscript, 
		paste('RF_', st, '_', names(x)[i], '_PP.eps', sep=''))
	}
	dev.off()
	setwd('../..')
}

# Run method on the six stations
VarImp_Effet_RF(rep_comp, 'REP')
VarImp_Effet_RF(hri_comp, 'HRI')
VarImp_Effet_RF(jus_comp, 'JUS')
VarImp_Effet_RF(gcm_comp, 'GCM')
VarImp_Effet_RF(gui_comp, 'GUI')
VarImp_Effet_RF(ail_comp, 'AIL')


